# PsychoPy plugins for OpenSesame

Copyright (2016-2023) Sebastiaan Mathôt


## Installation

In a terminal:

~~~
pip install psychopy-plugin-opensesame
~~~


See also:

- https://rapunzel.cogsci.nl/manual/environment/


## About

Currently, there are two plugins:

- `psychopy_gratingstim`
- `psychopy_textstim`

The [GratingStim](http://www.psychopy.org/api/visual/gratingstim.html) and [TextStim](http://www.psychopy.org/api/visual/textstim.html) are visual stimuli from PsychoPy, a Python library for psychology. With these plugins, you can use these stimuli easily within OpenSesame, a graphical experiment builder for the social sciences. You can use the plugin in OpenSesame [coroutines](http://osdoc.cogsci.nl/3.1/manual/structure/coroutines/), and adjust their properties periodically; this allows you, for example, to implement a drifting gabor patch.


## License

This software is distributed under the terms of the GNU General Public License 3. The full license should be included in the file `COPYING`, or can be obtained from:

- <http://www.gnu.org/licenses/gpl.txt>
